data.raw.lamp["small-lamp"].fast_replaceable_group = "lamp"
-- data.raw.lamp["small-lamp"].collision_box = {{-0.40, -0.40}, {0.40, 0.40}}
local black_entity = table.deepcopy(data.raw.lamp["small-lamp"])
data.raw.lamp["small-lamp"].next_upgrade = "black-flip-dot"

black_entity.name = "black-flip-dot"
black_entity.minable.result = "black-flip-dot"
black_entity.darkness_for_all_lamps_on = 1.0
black_entity.darkness_for_all_lamps_off = 1.0
black_entity.light.intensity = 0.0
black_entity.light_when_colored.intensity = 0.0
black_entity.glow_size = 0
black_entity.energy_usage_per_tick = "100W"
black_entity.next_upgrade = "small-lamp"
--black_entity.collision_box = {{-0.45, -0.45}, {0.45, 0.45}}
black_entity.selection_box = {{-0.5, -0.5}, {0.5, 0.5}}

black_entity.picture_off =
{
  layers =
  {
    {
      filename = "__flip-dots__/black-off.png",
      priority = "high",
      width = 42,
      height = 36,
      frame_count = 1,
      axially_symmetrical = false,
      direction_count = 1,
      shift = util.by_pixel(0,3),
    },
    {
      filename = "__base__/graphics/entity/small-lamp/lamp-shadow.png",
      priority = "high",
      width = 38,
      height = 24,
      frame_count = 1,
      axially_symmetrical = false,
      direction_count = 1,
      shift = util.by_pixel(4,5),
      draw_as_shadow = true,
    }
  }
}

black_entity.picture_on =
{
  filename = "__flip-dots__/flip-mask.png",
  priority = "high",
  width = 42,
  height = 36,
  frame_count = 1,
  axially_symmetrical = false,
  direction_count = 1,
  shift = util.by_pixel(0,3),
}

black_entity.signal_to_color_mapping =
{
  {type = "virtual", name = "signal-red",    color = {r = 1, g = 0.02, b = 0.02}},
  {type = "virtual", name = "signal-green",  color = {r = 0.02, g = 1, b = 0.02}},
  {type = "virtual", name = "signal-blue",   color = {r = 0.02, g = 0.5, b = 1}},
  {type = "virtual", name = "signal-yellow", color = {r = 1, g = 1, b = 0.02}},
  {type = "virtual", name = "signal-pink",   color = {r = 1, g = 0.02, b = 0.5}},
  {type = "virtual", name = "signal-cyan",   color = {r = 0.02, g = 1, b = 1}},
  {type = "virtual", name = "signal-white",  color = {r = 1, g = 1, b = 1}},
  {type = "virtual", name = "signal-grey",   color = {r = 0.5, g = 0.5, b = 0.5}},
  {type = "virtual", name = "signal-black",  color = {r = 1.0, g = 0.4, b = 0.02}},
}

black_entity.circuit_connector_sprites = nil
black_entity.circuit_wire_connection_point.wire.red = {0.35, 0.5}
black_entity.circuit_wire_connection_point.wire.green = {0.40, 0.5}
black_entity.circuit_wire_connection_point.shadow.red = {0.37, 0.52}
black_entity.circuit_wire_connection_point.shadow.green = {0.42, 0.52}

local black_item = table.deepcopy(data.raw["item"]["small-lamp"])

black_item.name = "black-flip-dot"
black_item.icons = {
  {
    icon = "__flip-dots__/black-icon.png",
    icon_size = 42,
    order = "a[light]-b[black-flip-dot]",
  },
}
black_item.place_result = "black-flip-dot"

local black_recipe = table.deepcopy(data.raw["recipe"]["small-lamp"])

black_recipe.enabled = true
black_recipe.name = "black-flip-dot"
black_recipe.ingredients = {{"iron-plate", 1}, {"electric-engine-unit", 1}, {"electronic-circuit", 1}}
black_recipe.result = "black-flip-dot"

data:extend{black_entity, black_item, black_recipe}

-- white version

-- local white_entity = table.deepcopy(black_entity)
-- local white_item = table.deepcopy(black_item)
-- local white_recipe = table.deepcopy(black_recipe)

-- white_entity.name = "white-flip-dot"
-- white_entity.minable.result = "white-flip-dot"
-- white_entity.picture_off =
-- {
  -- layers =
  -- {
    -- {
      -- filename = "__flip-dots__/white-off.png",
      -- priority = "high",
      -- width = 42,
      -- height = 36,
      -- frame_count = 1,
      -- axially_symmetrical = false,
      -- direction_count = 1,
      -- shift = util.by_pixel(0,3),
    -- },
    -- {
      -- filename = "__base__/graphics/entity/small-lamp/lamp-shadow.png",
      -- priority = "high",
      -- width = 38,
      -- height = 24,
      -- frame_count = 1,
      -- axially_symmetrical = false,
      -- direction_count = 1,
      -- shift = util.by_pixel(4,5),
      -- draw_as_shadow = true,
    -- }
  -- }
-- }

-- white_entity.signal_to_color_mapping =
-- {
  -- {type = "virtual", name = "signal-red",    color = {r = 0.8, g = 0.02, b = 0.02}},
  -- {type = "virtual", name = "signal-green",  color = {r = 0.02, g = 0.8, b = 0.02}},
  -- {type = "virtual", name = "signal-blue",   color = {r = 0.02, g = 0.5, b = 1}},
  -- {type = "virtual", name = "signal-yellow", color = {r = 0.8, g = 0.8, b = 0.02}},
  -- {type = "virtual", name = "signal-pink",   color = {r = 0.8, g = 0.02, b = 0.5}},
  -- {type = "virtual", name = "signal-cyan",   color = {r = 0.02, g = 0.8, b = 0.8}},
  -- {type = "virtual", name = "signal-white",  color = {r = 0.8, g = 0.8, b = 0.8}},
  -- {type = "virtual", name = "signal-grey",   color = {r = 0.5, g = 0.5, b = 0.5}},
  -- {type = "virtual", name = "signal-black",  color = {r = 0.02, g = 0.02, b = 0.02}},
-- }

-- white_recipe.name = "white-flip-dot"
-- white_recipe.result = "white-flip-dot"
-- white_item.name = "white-flip-dot"
-- white_item.icons = {
  -- {
    -- icon = "__flip-dots__/white-icon.png",
    -- icon_size = 42,
    -- order = "a[light]-b[white-flip-dot]",
  -- },
-- }
-- white_item.place_result = "white-flip-dot"
-- white_entity.next_upgrade = "small-lamp"
-- data:extend{white_entity, white_item, white_recipe}
